using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Xml;
using System.IO;
using System.Net;
using System.Text;

namespace BarcodeSample
{
	/// <summary>
	/// XLo[R[hƂAmazon WebT[rXpĐi̊֘A\Eۑ
	/// </summary>
	public class BarcodeForm : System.Windows.Forms.Form
	{
		#region ϐ̐錾
		//fobO[h𗘗p邩H
		bool Debug = false;
		//uEUŃA}]URLJH
		//bool BrowserEnabled = false;
		//ʂۑ邩H
		bool SaveEnabled = true;
		//A}]ID/Tokenۑ邩?
		bool AmazonSaveEnabled = true;

		//ACeXg̕ۑɗp镶R[h
		Encoding itemFileCode = Encoding.Unicode;


		//ACeXg̃Xgt@C
		string itemFileName = Application.StartupPath + @"\items.txt";
		//A}]A\VGCgIDi[t@C
		string amazonFileName = Application.StartupPath + @"\amazon.txt";
		//։摜̃t@C
		string noImageFileName = Application.StartupPath + @"\noimage.jpg";

		//̃nbV
		Hashtable itemHolder = new Hashtable();

		//listBoxItems̔rp̕ϐ
		bool listBoxChanging = false;
		bool listBoxDeleting =false;
		bool textBoxIdUpdating=false;

		//o[R[h̎
		enum BarcodeType{ISBN, UPC, EAN, OTHER};
		//o[R[h͂iEnterꂽjtrue. 
		bool inputEndFlag = false;
		#endregion 

		#region RXgN^EfXgN^EȈ
		public BarcodeForm()
		{
			InitializeComponent();
			
			Debug = checkBoxDebug.Checked;
			AmazonSaveEnabled = checkBoxAmazonEnabled.Checked;
			SaveEnabled = checkBoxSave.Checked;
		
			LoadItems();
			LoadAmazonSetting();
		}

		~BarcodeForm()
		{

		}

		protected override void Dispose( bool disposing )
		{
			SaveItems();
			SaveAmazonSetting();

			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}

			base.Dispose( disposing );
		}
		#endregion

		#region WindowstH[̐錾
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.TextBox textBoxId;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox textBoxKind;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.TextBox textBoxTitle;
		private System.Windows.Forms.TextBox textBoxAuthor;
		private System.Windows.Forms.TextBox textBoxPublisher;
		private System.Windows.Forms.TextBox textBoxYear;
		private System.Windows.Forms.TextBox textBoxCost;
		private System.Windows.Forms.PictureBox pictureBoxImage;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.Label label10;
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.CheckBox checkBoxAmazonEnabled;
		private System.Windows.Forms.CheckBox checkBoxSave;
		private System.Windows.Forms.TextBox textBoxAmazonId;
		private System.Windows.Forms.TextBox textBoxAmazonToken;
		private System.Windows.Forms.TextBox textBoxMessage;
		private System.Windows.Forms.Label label11;
		private System.Windows.Forms.TextBox textBoxASIN;
		private System.Windows.Forms.Label label12;
		private System.Windows.Forms.ListBox listBoxItems;
		private System.Windows.Forms.Label label13;
		private System.Windows.Forms.CheckBox checkBoxDebug;
		#endregion

		#region Windows Form Designer generated code
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
			this.textBoxId = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.textBoxKind = new System.Windows.Forms.TextBox();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.label11 = new System.Windows.Forms.Label();
			this.textBoxASIN = new System.Windows.Forms.TextBox();
			this.pictureBoxImage = new System.Windows.Forms.PictureBox();
			this.label8 = new System.Windows.Forms.Label();
			this.textBoxCost = new System.Windows.Forms.TextBox();
			this.label7 = new System.Windows.Forms.Label();
			this.textBoxYear = new System.Windows.Forms.TextBox();
			this.textBoxPublisher = new System.Windows.Forms.TextBox();
			this.label5 = new System.Windows.Forms.Label();
			this.textBoxAuthor = new System.Windows.Forms.TextBox();
			this.label4 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.textBoxTitle = new System.Windows.Forms.TextBox();
			this.label6 = new System.Windows.Forms.Label();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.checkBoxAmazonEnabled = new System.Windows.Forms.CheckBox();
			this.textBoxAmazonToken = new System.Windows.Forms.TextBox();
			this.label10 = new System.Windows.Forms.Label();
			this.textBoxAmazonId = new System.Windows.Forms.TextBox();
			this.label9 = new System.Windows.Forms.Label();
			this.groupBox3 = new System.Windows.Forms.GroupBox();
			this.checkBoxDebug = new System.Windows.Forms.CheckBox();
			this.checkBoxSave = new System.Windows.Forms.CheckBox();
			this.textBoxMessage = new System.Windows.Forms.TextBox();
			this.label12 = new System.Windows.Forms.Label();
			this.listBoxItems = new System.Windows.Forms.ListBox();
			this.label13 = new System.Windows.Forms.Label();
			this.groupBox1.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.groupBox3.SuspendLayout();
			this.SuspendLayout();
			// 
			// textBoxId
			// 
			this.textBoxId.Location = new System.Drawing.Point(112, 16);
			this.textBoxId.Name = "textBoxId";
			this.textBoxId.ReadOnly = true;
			this.textBoxId.Size = new System.Drawing.Size(128, 19);
			this.textBoxId.TabIndex = 0;
			this.textBoxId.Text = "";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(72, 16);
			this.label1.TabIndex = 1;
			this.label1.Text = "o[R[hID";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 48);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(88, 16);
			this.label2.TabIndex = 3;
			this.label2.Text = "o[R[h̎";
			// 
			// textBoxKind
			// 
			this.textBoxKind.Location = new System.Drawing.Point(112, 48);
			this.textBoxKind.Name = "textBoxKind";
			this.textBoxKind.ReadOnly = true;
			this.textBoxKind.Size = new System.Drawing.Size(128, 19);
			this.textBoxKind.TabIndex = 1;
			this.textBoxKind.Text = "";
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.label11,
																					this.textBoxASIN,
																					this.pictureBoxImage,
																					this.label8,
																					this.textBoxCost,
																					this.label7,
																					this.textBoxYear,
																					this.textBoxPublisher,
																					this.label5,
																					this.textBoxAuthor,
																					this.label4,
																					this.label3,
																					this.textBoxTitle,
																					this.label6});
			this.groupBox1.Location = new System.Drawing.Point(256, 8);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(216, 296);
			this.groupBox1.TabIndex = 5;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "ڍ׏";
			// 
			// label11
			// 
			this.label11.Location = new System.Drawing.Point(18, 16);
			this.label11.Name = "label11";
			this.label11.Size = new System.Drawing.Size(48, 16);
			this.label11.TabIndex = 13;
			this.label11.Text = "ASIN";
			// 
			// textBoxASIN
			// 
			this.textBoxASIN.Location = new System.Drawing.Point(96, 16);
			this.textBoxASIN.Name = "textBoxASIN";
			this.textBoxASIN.ReadOnly = true;
			this.textBoxASIN.TabIndex = 7;
			this.textBoxASIN.Text = "";
			// 
			// pictureBoxImage
			// 
			this.pictureBoxImage.Location = new System.Drawing.Point(96, 168);
			this.pictureBoxImage.Name = "pictureBoxImage";
			this.pictureBoxImage.Size = new System.Drawing.Size(112, 120);
			this.pictureBoxImage.TabIndex = 11;
			this.pictureBoxImage.TabStop = false;
			// 
			// label8
			// 
			this.label8.Location = new System.Drawing.Point(16, 160);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(64, 16);
			this.label8.TabIndex = 10;
			this.label8.Text = "摜";
			// 
			// textBoxCost
			// 
			this.textBoxCost.Location = new System.Drawing.Point(96, 136);
			this.textBoxCost.Name = "textBoxCost";
			this.textBoxCost.ReadOnly = true;
			this.textBoxCost.TabIndex = 12;
			this.textBoxCost.Text = "";
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(16, 136);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(40, 16);
			this.label7.TabIndex = 8;
			this.label7.Text = "i";
			// 
			// textBoxYear
			// 
			this.textBoxYear.Location = new System.Drawing.Point(96, 112);
			this.textBoxYear.Name = "textBoxYear";
			this.textBoxYear.ReadOnly = true;
			this.textBoxYear.TabIndex = 11;
			this.textBoxYear.Text = "";
			// 
			// textBoxPublisher
			// 
			this.textBoxPublisher.Location = new System.Drawing.Point(96, 88);
			this.textBoxPublisher.Name = "textBoxPublisher";
			this.textBoxPublisher.ReadOnly = true;
			this.textBoxPublisher.TabIndex = 10;
			this.textBoxPublisher.Text = "";
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(16, 88);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(56, 16);
			this.label5.TabIndex = 4;
			this.label5.Text = "oŎ";
			// 
			// textBoxAuthor
			// 
			this.textBoxAuthor.Location = new System.Drawing.Point(96, 64);
			this.textBoxAuthor.Name = "textBoxAuthor";
			this.textBoxAuthor.ReadOnly = true;
			this.textBoxAuthor.TabIndex = 9;
			this.textBoxAuthor.Text = "";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(16, 64);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(56, 16);
			this.label4.TabIndex = 2;
			this.label4.Text = "";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(16, 40);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(48, 16);
			this.label3.TabIndex = 1;
			this.label3.Text = "^Cg";
			// 
			// textBoxTitle
			// 
			this.textBoxTitle.Location = new System.Drawing.Point(96, 40);
			this.textBoxTitle.Name = "textBoxTitle";
			this.textBoxTitle.ReadOnly = true;
			this.textBoxTitle.TabIndex = 8;
			this.textBoxTitle.Text = "";
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(16, 112);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(72, 16);
			this.label6.TabIndex = 6;
			this.label6.Text = "sN";
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.checkBoxAmazonEnabled,
																					this.textBoxAmazonToken,
																					this.label10,
																					this.textBoxAmazonId,
																					this.label9});
			this.groupBox2.Location = new System.Drawing.Point(8, 96);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(232, 120);
			this.groupBox2.TabIndex = 3;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Amazon֘A̐ݒ";
			// 
			// checkBoxAmazonEnabled
			// 
			this.checkBoxAmazonEnabled.Checked = true;
			this.checkBoxAmazonEnabled.CheckState = System.Windows.Forms.CheckState.Checked;
			this.checkBoxAmazonEnabled.Location = new System.Drawing.Point(8, 88);
			this.checkBoxAmazonEnabled.Name = "checkBoxAmazonEnabled";
			this.checkBoxAmazonEnabled.Size = new System.Drawing.Size(168, 24);
			this.checkBoxAmazonEnabled.TabIndex = 4;
			this.checkBoxAmazonEnabled.Text = "A}]IDTokenۑ";
			this.checkBoxAmazonEnabled.CheckedChanged += new System.EventHandler(this.checkBoxAmazonEnabled_CheckedChanged);
			// 
			// textBoxAmazonToken
			// 
			this.textBoxAmazonToken.Location = new System.Drawing.Point(112, 64);
			this.textBoxAmazonToken.Name = "textBoxAmazonToken";
			this.textBoxAmazonToken.Size = new System.Drawing.Size(112, 19);
			this.textBoxAmazonToken.TabIndex = 3;
			this.textBoxAmazonToken.Text = "";
			// 
			// label10
			// 
			this.label10.Location = new System.Drawing.Point(8, 64);
			this.label10.Name = "label10";
			this.label10.Size = new System.Drawing.Size(104, 16);
			this.label10.TabIndex = 2;
			this.label10.Text = "Developer Token";
			// 
			// textBoxAmazonId
			// 
			this.textBoxAmazonId.Location = new System.Drawing.Point(112, 32);
			this.textBoxAmazonId.Name = "textBoxAmazonId";
			this.textBoxAmazonId.Size = new System.Drawing.Size(112, 19);
			this.textBoxAmazonId.TabIndex = 2;
			this.textBoxAmazonId.Text = "";
			// 
			// label9
			// 
			this.label9.Location = new System.Drawing.Point(8, 32);
			this.label9.Name = "label9";
			this.label9.Size = new System.Drawing.Size(80, 16);
			this.label9.TabIndex = 0;
			this.label9.Text = "A\VGCgID";
			// 
			// groupBox3
			// 
			this.groupBox3.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.checkBoxDebug,
																					this.checkBoxSave});
			this.groupBox3.Location = new System.Drawing.Point(8, 232);
			this.groupBox3.Name = "groupBox3";
			this.groupBox3.Size = new System.Drawing.Size(232, 72);
			this.groupBox3.TabIndex = 4;
			this.groupBox3.TabStop = false;
			this.groupBox3.Text = "̑̐ݒ";
			// 
			// checkBoxDebug
			// 
			this.checkBoxDebug.Location = new System.Drawing.Point(8, 40);
			this.checkBoxDebug.Name = "checkBoxDebug";
			this.checkBoxDebug.Size = new System.Drawing.Size(168, 24);
			this.checkBoxDebug.TabIndex = 6;
			this.checkBoxDebug.Text = "fobObZ[W\";
			this.checkBoxDebug.CheckedChanged += new System.EventHandler(this.checkBoxDebug_CheckedChanged);
			// 
			// checkBoxSave
			// 
			this.checkBoxSave.Checked = true;
			this.checkBoxSave.CheckState = System.Windows.Forms.CheckState.Checked;
			this.checkBoxSave.Location = new System.Drawing.Point(8, 16);
			this.checkBoxSave.Name = "checkBoxSave";
			this.checkBoxSave.Size = new System.Drawing.Size(160, 24);
			this.checkBoxSave.TabIndex = 5;
			this.checkBoxSave.Text = "f[^ۑ";
			this.checkBoxSave.CheckedChanged += new System.EventHandler(this.checkBoxSave_CheckedChanged);
			// 
			// textBoxMessage
			// 
			this.textBoxMessage.Location = new System.Drawing.Point(480, 168);
			this.textBoxMessage.Multiline = true;
			this.textBoxMessage.Name = "textBoxMessage";
			this.textBoxMessage.ReadOnly = true;
			this.textBoxMessage.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.textBoxMessage.Size = new System.Drawing.Size(216, 136);
			this.textBoxMessage.TabIndex = 14;
			this.textBoxMessage.Text = "";
			// 
			// label12
			// 
			this.label12.Location = new System.Drawing.Point(488, 144);
			this.label12.Name = "label12";
			this.label12.Size = new System.Drawing.Size(64, 16);
			this.label12.TabIndex = 9;
			this.label12.Text = "bZ[W";
			// 
			// listBoxItems
			// 
			this.listBoxItems.ItemHeight = 12;
			this.listBoxItems.Location = new System.Drawing.Point(480, 40);
			this.listBoxItems.Name = "listBoxItems";
			this.listBoxItems.Size = new System.Drawing.Size(216, 88);
			this.listBoxItems.TabIndex = 13;
			this.listBoxItems.SelectedIndexChanged += new System.EventHandler(this.listBoxItems_SelectedIndexChanged);
			// 
			// label13
			// 
			this.label13.Location = new System.Drawing.Point(488, 16);
			this.label13.Name = "label13";
			this.label13.Size = new System.Drawing.Size(104, 16);
			this.label13.TabIndex = 11;
			this.label13.Text = "o^ς݂ID";
			// 
			// BarcodeForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.ClientSize = new System.Drawing.Size(704, 310);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.label13,
																		  this.listBoxItems,
																		  this.label12,
																		  this.textBoxMessage,
																		  this.groupBox3,
																		  this.groupBox2,
																		  this.groupBox1,
																		  this.textBoxKind,
																		  this.label2,
																		  this.label1,
																		  this.textBoxId});
			this.KeyPreview = true;
			this.Name = "BarcodeForm";
			this.Text = "BarcodeForm";
			this.KeyDown += new System.Windows.Forms.KeyEventHandler(this.BarcodeForm_KeyDown);
			this.groupBox1.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.groupBox3.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		#region Amazon֘Ȁ

		//Amazon WebT[rXpāCo[R[hIDD
		bool Search(string barcode, ref string result, string amazonId, string amazonToken)
		{
	
			BarcodeType type;
			string [] baseURLs;
			XmlDocument xmlDoc;

			//A}]IDTokenȂI
			if(amazonId == "" || amazonToken == "")
			{
				PrintError("A}]IDToken͂ĂD");
				return false;
			}
			
			BarcodePreCorrect(ref barcode);
			type = BarcodeCheckType(barcode);
			SetBarcodeType(type);

			baseURLs = 	new string[2]
			{
				@"http://xml.amazon.com/onca/xml3?t=" + amazonId + "&" + 
					@"dev-t="+ amazonToken + "&f=xml",
				@"http://xml.amazon.co.jp/onca/xml3?t=" + amazonId + "&" + 
					@"dev-t="+ amazonToken + "&f=xml&locale=jp"												};

			xmlDoc = new XmlDocument();

			if(type == BarcodeType.ISBN)
			{
				BarCodeDecodeISBN(ref barcode);		
				PrintDebug("ISBN");
		
				string baseURLOption = "&type=lite&mode=books&AsinSearch=";

				for(int i=0;i<baseURLs.Length;i++)
				{
					xmlDoc.Load(baseURLs[i] + baseURLOption+ barcode);
					if(xmlDoc.SelectSingleNode("/ProductInfo/ErrorMsg")!=null)
					{
						if(i==baseURLs.Length-1)
							PrintError(xmlDoc.SelectSingleNode("/ProductInfo/ErrorMsg").InnerText);
						continue;
					}
					else
					{
						if(!itemHolder.Contains(barcode))
						{
							ParseXML(xmlDoc, type);
							PrintDebug(":" + xmlDoc.InnerXml);
						}
						else
						{
							ParseHash(barcode);
						}
						
						return true;
					}
				}
				return false;
			}
			else if(type == BarcodeType.UPC)
			{				
				//UPC͗lXȐiɎg邽߁CmodeύXĕD
				string [] baseURLOptions = {
											   "&type=lite&mode=music&UpcSearch=",
											   "&type=heavy&mode=dvd&UpcSearch=",
											   "&type=lite&mode=electronics&UpcSearch=",
											   "&type=lite&mode=classical&UpcSearch=",
											   "&type=lite&mode=software&UpcSearch=",
											   "&type=lite&mode=videogames&UpcSearch="
										   };
				//UpcSearchUS̃A}]̂ݑΉ
				PrintDebug("UPC");
				for(int i=0;i<baseURLOptions.Length;i++)
				{	
					xmlDoc.Load(baseURLs[0] + baseURLOptions[i] + barcode);
				
					if(xmlDoc.SelectSingleNode("/ProductInfo/ErrorMsg")!=null)
					{
						if(i==baseURLOptions.Length-1)
							PrintDebug(xmlDoc.SelectSingleNode("/ProductInfo/ErrorMsg").InnerText);
						continue;	
					}
					else
					{
						if(!itemHolder.Contains(barcode))
						{
							ParseXML(xmlDoc, type);
							PrintDebug(":" + xmlDoc.InnerXml);
						}
						else
						{
							ParseHash(barcode);
						}
						
						return true;

					}
				}
				return false;
			}
			else if(type == BarcodeType.EAN)
			{
				PrintDebug("EAN");
				PrintError("EAN/JANR[ȟ͈܂D");
				return false;
			}
			else if (type == BarcodeType.OTHER)
			{
				
				PrintDebug("Other");
				PrintError("o[R[h̎ނFł܂D");
				return false;
			}
			else
			{
				return false;
			}
		}

		//o^ςID̃nbVo[R[hIDĕ\D
		private bool ParseHash(string id)
		{
			if(itemHolder.Contains(id))
			{
				Item item = (Item)itemHolder[id];
				UpdateComponents(item);
				return true;
			}
			else
			{
				return false;
			}
		}
		
		//Amazon WebT[rX̕ԂXMLCef[^𒊏o
		private void ParseXML(XmlDocument xmlDoc, BarcodeType type)
		{
			Item item = new Item();
			try
			{
				item.id ="";
				//ɎgID𒊏oD
				string searchMethod = "";
				if(type == BarcodeType.ISBN)
				{
					searchMethod ="AsinSearch";
				}
				else if(type == BarcodeType.UPC)
				{
					searchMethod = "UpcSearch";
				}
				XmlNodeList args= xmlDoc.SelectNodes("/ProductInfo/Request/Args/Arg"); 
				for(int j=0;j< args.Count;j++)
				{
					XmlNode node = args[j];
					XmlAttribute attribute = node.Attributes["name"];
				
					if(attribute.InnerText == searchMethod)
					{
						item.id = node.Attributes["value"].InnerText;
						break;
					}
				}

				if(xmlDoc.SelectSingleNode("/ProductInfo/Details/Asin") != null)
					item.asin = xmlDoc.SelectSingleNode("/ProductInfo/Details/Asin").InnerText;
				if(xmlDoc.SelectSingleNode("/ProductInfo/Details/ProductName")!= null)
					item.productName = xmlDoc.SelectSingleNode("/ProductInfo/Details/ProductName").InnerText;
			
				string catalog = "";
				XmlNodeList authors = null;
				if(xmlDoc.SelectSingleNode("/ProductInfo/Details/Catalog")!= null)
					catalog = xmlDoc.SelectSingleNode("/ProductInfo/Details/Catalog").InnerText;
			
				if(catalog == "Book")
				{
					authors = xmlDoc.SelectNodes("/ProductInfo/Details/Authors/Author"); 
				}
				else if(catalog == "Music")
				{
					authors = xmlDoc.SelectNodes("/ProductInfo/Details/Artists/Artist"); 
				}
				else if(catalog == "DVD")
				{
					authors = xmlDoc.SelectNodes("/ProductInfo/Details/Directors/Director"); 
				}
				else
				{
					//̑̏ꍇ()ȂD
					authors = xmlDoc.SelectNodes("/ProductInfo/Details/Authors/Author"); 		
				}
		
				for(int j=0;j<authors.Count;j++)
				{
					XmlNode node = authors.Item(j);
					item.author = item.author + "," + node.InnerText;
				}

				if(item.author != "")
					item.author = item.author.Substring(1);

				if(xmlDoc.SelectSingleNode("/ProductInfo/Details/Manufacturer") != null)
					item.publisher = xmlDoc.SelectSingleNode("/ProductInfo/Details/Manufacturer").InnerText;
				if(xmlDoc.SelectSingleNode("/ProductInfo/Details/ImageUrlLarge")!= null)
					item.imageURL =  xmlDoc.SelectSingleNode("/ProductInfo/Details/ImageUrlLarge").InnerText;
				if(xmlDoc.SelectSingleNode("/ProductInfo/Details/ListPrice") != null)
					item.listPrice = xmlDoc.SelectSingleNode("/ProductInfo/Details/ListPrice").InnerText;	
				if(xmlDoc.SelectSingleNode("/ProductInfo/Details/ReleaseDate") != null)
					item.year = xmlDoc.SelectSingleNode("/ProductInfo/Details/ReleaseDate").InnerText;

				UpdateComponents(item);

				if(item.asin!=null && item.asin !="")
				{
					if(!itemHolder.Contains(item.id))
						itemHolder.Add(item.id, item);//asin
					if(!listBoxItems.Items.Contains(item.id))
						listBoxItems.Items.Add(item.id);
				}

				//FꂽڂI
				for (int i=0;i<listBoxItems.Items.Count;i++)
				{
					if((string)listBoxItems.Items[i] == item.id)
					{
						listBoxItems.SetSelected(i, true);
						break;
					}
				}
			}
			catch(Exception ex)
			{
				PrintError(ex.ToString());
			}
			return;
		}

		#endregion
		
		#region o[R[h֘Ȁ
		//o[R[h[_[̓ǂݎG[␳i0Ŏn܂R[hǂނ00ƂĕԂj
		bool BarcodePreCorrect(ref string barcode)
		{
			if(barcode.StartsWith("0") && barcode.Length >12)
			{
				barcode = barcode.Substring(1);
				return true;
			}
			else
			{
				return false;
			}
		}

		//o[R[h̎ʂ𔻒肷D
		BarcodeType BarcodeCheckType(string barcode)
		{	
			//978Ŏn܂R[hISBN
			if(barcode.StartsWith("978"))
			{
				return BarcodeType.ISBN;
			}
			//ȊȌꍇ
			else
			{
				//12̃R[hUPC
				if(barcode.Length == 12)
				{
					return BarcodeType.UPC;
				}
				//13̃R[hEAN/JAN
				else if(barcode.Length == 13)
				{
					return BarcodeType.EAN;
				}
				//10̃R[h͏ςISBN
				else if(barcode.Length == 10)
				{
					return BarcodeType.ISBN;
				}
				else
				{
					return BarcodeType.OTHER;
				}
			}
		}
		
		//BarcodeTypeɉtextBoxKindɐݒ肷D
		void SetBarcodeType(BarcodeType type)
		{
			switch(type)
			{
				case BarcodeType.ISBN:
					textBoxKind.Text = "ISBN";
					break;
				case BarcodeType.UPC:
					textBoxKind.Text = "UPC";
					break;
				case BarcodeType.EAN:
					textBoxKind.Text = "EAN";
					break;
				default:
					textBoxKind.Text = "Other";
					break;
			}
			textBoxKind.Update();
		}

		//ISBNR[hf[^𒊏o
		bool BarCodeDecodeISBN(ref string barcode)
		{			
			//ISBNR[h
			if(barcode.StartsWith("978"))
			{
				barcode = barcode.Substring(3,9);
				
				int sum = 0;
				int checksum = 0;
				
				for(int i=0;i<9;i++)
				{
					sum = sum + (int.Parse(new String(barcode[i],1))) * (i+1);
				}
				checksum = sum % 11;

				if(checksum ==10)
				{
					barcode = barcode + "X";
				}
				else
				{
					barcode = barcode + checksum.ToString();
				}
				return true;
			}
			else
			{
				return false;
			}
		}
		#endregion

		#region WindowstH[֘ȀiAbvf[gCCxgCo[R[h͂Ȃǁj
		//eLXg{bNXȂǂɏڍ׏
		private void UpdateComponents(Item item)
		{
			textBoxId.Text = item.id;
			inputEndFlag = true;
			textBoxASIN.Text = item.asin;
			textBoxTitle.Text =  item.productName;
			textBoxAuthor.Text =  item.author;
			textBoxPublisher.Text =  item.publisher;
			textBoxCost.Text =  item.listPrice;
			textBoxYear.Text =  item.year;

			BarcodeType type = BarcodeCheckType(item.id);
			SetBarcodeType(type);
			if(item.imageURL != "")
			{
				HttpWebRequest request = (HttpWebRequest)WebRequest.Create(item.imageURL);
				HttpWebResponse response = (HttpWebResponse)request.GetResponse();
				Stream stream = response.GetResponseStream();
				Image image = Image.FromStream(stream);
				//Y摜ȂꍇC 1x1̃_~[摜Ԃ
				if(image.Width == 1 && image.Height == 1)
				{
					image = Image.FromFile(noImageFileName);
				}
				ResizeImageSize(pictureBoxImage, ref image);
				pictureBoxImage.Image = image;
			}
			else
			{
				Image image = Image.FromFile(noImageFileName);
				ResizeImageSize(pictureBoxImage, ref image);
				pictureBoxImage.Image = image;
			}
		}

		//摜PictureBox̃TCYɂ킹ďkD
		private bool ResizeImageSize(PictureBox box, ref Image image)
		{
			bool changed = false;
			int height=0, width=0;
			
			//widthʕȓɕۂ
			if(image.Width > box.Width)
			{    
				height = (int)(image.Height * ((float)box.Width / (float)image.Width));
				width = box.Width;
				
				changed =true;
			}
			//heightʂ̍ȓɕۂ
			if(image.Height > box.Height)
			{
				width = (int)(image.Width * ((float)box.Height / (float)image.Height));
				height = box.Height;
				changed = true;
			}

			if(changed)
				image = new Bitmap(image, width, height);

			return changed;
		}

		//o[R[h[_[̓́CуL[͂̏
		private void BarcodeForm_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			
			if(textBoxAmazonId.Focused || textBoxAmazonToken.Focused)
				return;

			if(e.KeyCode == Keys.Enter)
			{
				string result = "";
				Search(textBoxId.Text, ref result, textBoxAmazonId.Text, textBoxAmazonToken.Text);
				inputEndFlag = true;
				textBoxIdUpdating =false;
			}
			else if(e.KeyCode == Keys.Escape)
			{
				textBoxId.Text = "";
				inputEndFlag = false;
				textBoxIdUpdating =false;
			}
			else if(e.KeyCode == Keys.Delete )
			{	
				if(listBoxDeleting)
					return;
				if(listBoxItems.Focused)
				{
					listBoxDeleting = true;
					string key = (string)listBoxItems.SelectedItem;
					listBoxItems.Items.Remove(key);
					if(itemHolder.Contains(key))
					{
						itemHolder.Remove(key);
					}
					Item dummy = new Item();
					UpdateComponents(dummy);
					listBoxDeleting = false;
				}
			}
			else if(e.KeyCode == Keys.V &&e.Control)
			{
				textBoxIdUpdating = true;
				
				string clipData = (string)(Clipboard.GetDataObject().GetData("UnicodeText"));//Text

				if(clipData != null && clipData !="")
				{
					bool numberFlag = true;

					//󔒕C؂蕶CȊO̕܂܂ĂI
					for(int i=0;i<clipData.Length;i++)
					{
						if(!char.IsNumber(clipData,i))
						{
							if(char.IsWhiteSpace(clipData, i) || char.IsSeparator(clipData,i))
							{
								continue;
							}
							else
							{
								numberFlag = false;
								break;
							}
						}
					}
					if(numberFlag)
					{
						if(inputEndFlag)
						{
							textBoxId.Text = "";
							inputEndFlag = false;
						}

						for(int i=0;i<clipData.Length;i++)
						{
							if(!char.IsWhiteSpace(clipData, i) && !char.IsSeparator(clipData,i))
							{
								textBoxId.Text = textBoxId.Text + (char)clipData[i];
							}
						}
						inputEndFlag = true;
					}		
					return;
				}
			}
			else
			{	 		
				//͂ꂽL[l̏ꍇ̂݃eLXg{bNXɉD
				if(char.IsNumber((char)e.KeyValue))
				{
					textBoxIdUpdating = true;
					if(inputEndFlag)
					{
						textBoxId.Text = "";
						inputEndFlag = false;
					}

					textBoxId.Text = textBoxId.Text + (char)e.KeyValue;
				}
				else
				{	
					//ȂD
				}
			}
		}

		private void checkBoxAmazonEnabled_CheckedChanged(object sender, System.EventArgs e)
		{
			AmazonSaveEnabled = checkBoxAmazonEnabled.Checked;
		}

		private void checkBoxSave_CheckedChanged(object sender, System.EventArgs e)
		{
			SaveEnabled = checkBoxSave.Checked;
		}

		private void checkBoxDebug_CheckedChanged(object sender, System.EventArgs e)
		{
			Debug = checkBoxDebug.Checked;
		}
		//ListBox̑IԂςꍇCڍ׏XVD
		private void listBoxItems_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			//݃ACeύXȂI
			if(listBoxChanging || listBoxDeleting || textBoxIdUpdating)
				return;

			listBoxChanging = true;
			
			string key = (string)listBoxItems.SelectedItem;
			
			if(itemHolder.Contains(key))
			{
				Item item = (Item)(itemHolder[key]);
				UpdateComponents(item);
			}
			else
			{
				PrintError("ID܂D");
			}
			listBoxChanging = false;
		}
		#endregion
		
		#region Utilityñ\bhibZ[WóCSave/Load)

		private void PrintMessage(string m, params object []args)
		{
			
			string message = String.Format(m, args);
			textBoxMessage.Text = message + "\r\n" + textBoxMessage.Text;
		}

		private void PrintDebug(string m, params object []args)
		{
			if(Debug)
			{
				PrintMessage(m,args);
			}
		}

		private void PrintError(string m, params object []args)
		{
			PrintMessage("Error: " + m, args);
		}

		//o^ς݂IDƊ֘At@CɕۑD
		private void SaveItems()
		{	
			if(!SaveEnabled)
				return;

			StreamWriter writer = new StreamWriter(itemFileName, false, itemFileCode);
			try
			{
				foreach(Item item in itemHolder.Values)
				{
					if(item == null)	break;
				
					string message = string.Format("{0}\t{1}\t{2}\t{3}\t{4}\t{5}\t{6}\t{7}",
										item.id, item.asin, item.productName, item.author, 
										item.publisher, item.year, item.listPrice,   item.imageURL);
					writer.WriteLine(message);
				}
			}
			catch(Exception ex)
			{
				PrintError(ex.ToString());
			}
			writer.Close();
		}

		//o^ς݂IDƊ֘At@C烍[hCnbVƃXg{bNXɒǉ
		private void LoadItems()
		{
			if(!File.Exists(itemFileName)) return;

			StreamReader reader = new StreamReader(itemFileName,itemFileCode);

			try
			{
				while(true)
				{
					string line = reader.ReadLine();
					if(line == null) break;
					string [] data = line.Split('\t');
					if(data.Length<3)continue;

					string id = (string)data[0];
					string asin = (string)data[1];
					string productName = (string)data[2];
					string author = (string)data[3];
					string publisher = (string)data[4];
					string year =(string)data[5];
					string listPrice =(string)data[6];
					string imageURL = (string)data[7];
					
					if(!itemHolder.Contains(id))
					{
						itemHolder.Add(id,  new Item(id, asin, productName, author, publisher, listPrice, year, imageURL));
					}
					if(!listBoxItems.Items.Contains(id))
					{
						listBoxItems.Items.Add(id);
					}
				}
			}
			catch(Exception ex)
			{
				PrintError(ex.ToString());
			}
			reader.Close();
		}
	
		//Amazon IDDeveloper's Tokent@Cɕۑ
		private void SaveAmazonSetting()
		{	
			if(textBoxAmazonId.Text =="" || textBoxAmazonToken.Text == "")
				return;

			//IDۑȂݒ̏ꍇCIDt@C݂Ă΍폜
			if(!AmazonSaveEnabled)
			{
				if(File.Exists(amazonFileName))
					File.Delete(amazonFileName);
				return;
			}

			StreamWriter writer = new StreamWriter(amazonFileName, false);

			try
			{	
				string line = string.Format("{0}\t{1}",textBoxAmazonId.Text, textBoxAmazonToken.Text);
				writer.WriteLine(line);
			}
			catch(Exception ex)
			{
				PrintError(ex.ToString());
			}
			writer.Close();
		}

		//Amazon IDDeveloper's Tokent@Cǂݍ
		private void LoadAmazonSetting()
		{
			if(!File.Exists(amazonFileName)) return;

			StreamReader reader = new StreamReader(amazonFileName);

			try
			{
			
				string line = reader.ReadLine();
				if(line != null)
				{
					string [] data = line.Split('\t');
					if(data.Length >=2)
					{
						string amazonId = (string)data[0];
						string amazonKey = (string)data[1];		
						if(amazonId != "")
							textBoxAmazonId.Text = amazonId;
						if(amazonKey !="")
							textBoxAmazonToken.Text = amazonKey;
					}		
				}
			}
			catch(Exception ex)
			{
				PrintError(ex.ToString());
			}
			reader.Close();
		}

		#endregion


		[STAThread]
		static void Main(string[] args)
		{
			Application.Run(new BarcodeForm());
		}

	}
}
